unit templatecomponent;
{
The preprocessor will handle multiple files, project files, and
other necessities, This one just handles one or more components
and "Raw" PSP - straight HTML with VAR,WECOMPONENTS, and code embedded
and produce any necessary Pascal Units needed
}
interface
uses sysutils,classes,strutils,lowx,pspbase,preprocessevents,
     preprocessexecutable,preprocessmethods,preprocessvars,
     preprocessuses,preprocessproperties,preprocesswebcomponents,
     preprocesstypeconst;

function produceUnitfromPSP(unitname:String;ComponentData:String):String;
function processComponentFromExeBlock (Name,execblock:String):String;
{
in version 1.0.. maybe 1.5
procedure produceRPCServerfromPSP(ComponentData:String);
procedure produceRPClientfromPSP(ComponentData:String);
}

implementation

function TrimWhite(data:String):String;
var i:integer;c:Char;cs,outhold:String;
begin
for i:= 1 to length(data) do
 begin
   cs:=Uppercase(data[i]);
   c:=cs[1];
   if ((c>#20) and (c<#126)) then outhold:=outhold+cs;
 end;
result:=outhold;
end;

function processSingleComponentInterface(classname,Data:String):String;
begin
{accept one componenttag and produce the interface for it.}
 result:= classname+' = class(TPSPObject)'+#13+#10;
 result := result + 'private'+#13+#10;
 result := result +  producePropertiesPrivatedeclaration (Data );
 result:=result + produceEventsPrivateStatement(Data);
 result:=result + produceWCPrivateDeclaration(Data);
 result:=result+'public'+#13+#10;
 result:=result+' constructor create(Aowner:TComponent);override;'+#13+#10;
 result:=result+' destructor destroy;override;'+#13+#10;
 result:=result+' procedure Execute;'+#13+#10;
 result:=result+produceMethodsPublicdeclaration(data) +#13+#10;
 result:=result+'published'+#13+#10;
 result:=result+ producePropertiesPublisheddeclaration (Data);
 result:=result+ produceWCPublishedDeclaration (Data);
 result:=result+ produceEventsPublishedStatement (Data);
 result:=result+'end;'  +#13+#10;
 //writeln(result);
end;

function produceConstructor (classname,data:String):String;
var outhold:String; wclist:tstringlist;i:integer;
begin
outhold:='';
outhold:=outhold+' constructor '+classname+'.create(Aowner:TComponent);'+#13+#10;
 outhold:=outhold+'begin'+#13+#10;
 outhold:=outhold+'inherited create(aowner);'+#13+#10;    
  wclist:=GetTermTagList(data,'WEBCOMPONENT');
  for i:= 0 to wclist.count-1 do
  outhold:=outhold+produceWebComponentcreateStatement(wclist[i]);
 outhold:=outhold+'end;'+#13+#10;
 result:=outhold;
 
end;

function produceDestructor (classname,data:String):String;
var outhold:String; wclist:Tstringlist;i:integer;
begin
 outhold:=outhold+' destructor '+classname+'.destroy;'+#13+#10;
  outhold:=outhold+'begin'+#13+#10;
  wclist:=GetTermTagList(data,'WEBCOMPONENT');
 for i:= 0 to wclist.count-1 do
  outhold:=outhold+produceWebComponentdestroyStatement(wclist[i]);
 outhold:=outhold+'end;'+#13+#10;
  result:=outhold;
 
end;

function produceExecution (classname,data:String):String;
var outhold,datahold:String;wclist:tstringlist;i:integer;
begin
 outhold:=outhold+' procedure '+classname+'.Execute;'+#13+#10;
 outhold:=outhold+producevarstatement(data);
 outhold:=outhold+'begin'+#13+#10;
 wclist:=GetTermTagList(data,'WEBCOMPONENT');
//writeln('ready to insert component segments ');

 datahold:=data;
  
 if wclist.count>0 then
 for i:= 0 to wclist.count-1 do
   begin
     while pos(wclist[i],datahold)<>0 do datahold:=replacestring(datahold,wclist[i],'<%' + produceWebcomponentExecutionstatement(wclist[i])+'%>');
   end;
 //writeln('Outputting main exe block  ');
 
 outhold:=outhold+ produceexecutablestatement(GetTagData(datahold,'COMPONENT'),NO_DEBUG);
 outhold:=outhold+'end;'+#13+#10;
  result:=outhold;
 
end;

function processSingleComponentImplementation(classname,Data:String):String;
var  outhold:string;
begin
{accept one component tag and produce the implementation for it.}

{}
outhold:='';
outhold:=outhold+produceMethodsImplementation (classname,data);
////writeln('Methods completed');
outhold:=outhold+produceconstructor(classname,data);
 outhold:=outhold+producedestructor(classname,data);
 ////writeln('constuct/destruct completed');
outhold:=outhold+produceexecution(classname,data);
////writeln('ExeBlock completed');
////writeln ( outhold);
result:=outhold;
end;

function processComponentFromExeBlock (Name,execblock:String):String;
var outhold:String;
begin
{simple wrapper for a given block of code}
outhold:='';
outhold:=outhold+'<COMPONENT CLASS="'+Name+'" PROPERTIES="">';
outhold:=outhold+execblock;
outhold:=outhold+'</COMPONENT>';
result:=outhold;
end;

function produceUnitfromPSP(unitname:String;ComponentData:String):String;
var outhold:String;
    compslist:TStringlist;
    procdefs,execblock,testblock,pspmain,thiscomp,thisname,
    holdxtype,holdxconst:String;
    i:integer;
begin
{outhold:= outhold + '' + #13+#10;}
outhold:= 'unit PSP_WC'+unitname+' ;'+ #13+#10;
outhold:= outhold+'interface'+#13+#10;
outhold:= outhold + ProduceUsesStatement(ComponentData) + #13+#10;

{a: pull const and type blocks, if any}

holdxtype:= produceExtraTypeDeclaration(ComponentData);
holdxconst:= produceExtraConstDeclaration(ComponentData);
if holdxconst<>'' then outhold:=outhold + 'const' +#13+#10 + holdxconst;
if holdxtype<>'' then outhold:=outhold + 'type' +#13+#10 + holdxtype;

{1: Pull out our components}
compslist:=tstringlist.create;
compslist:=GetTagList (ComponentData,'COMPONENT');




{2: Get our executable block and wrap in a component}
execblock:=ComponentData;
for i:= 0 to compslist.count-1 do
 begin
  thiscomp:=compslist[i];
  execblock:=Replacestring(execblock,compslist[i],'') ;
 end;
  {now we have the exec block}

  {now we only want to add it if anything is there...}
  testblock:=execblock;
  while pos(#13+#10,testblock)<>0 do testblock:=replacestring(testblock,#13+#10,'');
  while pos(' ',testblock)<>0 do testblock:=replacestring(testblock,' ','');
  if testblock <> '' then
     begin
     pspmain:= processComponentFromExeBlock ('_PSPMain',execblock);
     compslist.add (pspmain);
     end;

{3: Now Run through the components list and build our Interface section}

{put that type header out there!}
if compslist.count>0 then outhold:=outhold+'type'+#13+#10;


for i:= 0 to compslist.count-1 do
 begin
  thiscomp:= compslist[i];
  thisname:= GetTagProperty (thiscomp,'COMPONENT','CLASS');

  outhold:=outhold + '{Events: '+thisname+'}'+#13+#10;
  outhold:=outhold + produceEventsTypeDeclarations(thiscomp)+#13+#10+#13+#10;
  outhold:=outhold + '{Component Definition: '+thisname+'}'+#13+#10;
  outhold:=outhold + processSingleComponentInterface(thisname,thiscomp)+#13+#10;
 end;

{4: Now process the implementation}
outhold:=outhold+#13+#10+'implementation'+#13+#10;

{5: Now process the implementation of all our components}
for i:= 0 to compslist.count-1 do
 begin
  thiscomp:= compslist[i];
  thisname:= GetTagProperty (thiscomp,'COMPONENT','CLASS');

  outhold:=outhold + '{Component Implementation: '+thisname+'}'+#13+#10;
  outhold:=outhold + processSingleComponentImplementation(thisname,thiscomp)+#13+#10;
 end;

{6:finish up and return}
outhold:=outhold+#13+#10+'end.'+#13+#10;

result:=outhold;
end;




end.